---
title: 'PaymentRequest: merchantvalidation event'
slug: Web/API/PaymentRequest/merchantvalidation_event
tags:
  - API
  - Commerce
  - Merchant
  - Payment Handler
  - Payment Request
  - Payment Request API
  - Reference
  - Sales
  - Validation
  - Web
  - events
  - merchantvalidation
  - payment
---
<div>{{deprecated_header}}{{non-standard_header}}{{securecontext_header}}</div>

<p><span class="seoSummary"><code><strong>merchantvalidation</strong></code> events are delivered by the <a href="/en-US/docs/Web/API/Payment_Request_API">Payment Request API</a> to a {{domxref("PaymentRequest")}} object when a payment handler requires that the merchant requesting the purchase validate itself as permitted to use the payment handler.</span></p>

<p>See {{SectionOnPage("/en-US/docs/Web/API/Payment_Request_API/Concepts", "Merchant validation")}} for details on how the merchant validation process works.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("MerchantValidationEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("PaymentRequest.onmerchantvalidation", "onmerchantvalidation")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<p>In this example, an event handler is established for the <code>merchantvalidation</code> event. It uses the {{domxref("WindowOrWorkerGlobalScope.fetch", "fetch()")}} to send a request to its own server with an argument of the payment method's validation URL, obtained from the event's {{domxref("MerchantValidationEvent.validationURL", "validationURL")}} property. The merchant server should access the validation URL in accordance with the payment method documention. Typically, a client should not access the validation URL.</p>

<pre class="brush: js notranslate">request.addEventListener("merchantvalidation", event =&gt; {
  event.complete(async () =&gt; {
    const merchantServerUrl = window.location.origin +
        '/validate?url=' + encodeURIComponent(event.validationURL);
    // get validation data, and complete validation;
    return await fetch(merchantServerUrl).then(response =&gt; response.text());
  }, false);
};

const response = await request.show();</pre>

<p>How merchant server handles the validation depends on the server implementation and payment method documentation. The content delivered by the validation server is forwarded to the merchant server and is then returned from the <code>fetch()</code> call's fulfillment handler to the {{domxref("MerchantValidationEvent.complete", "complete()")}} method on the event. This response lets the payment handler know if the merchant is validated.</p>

<p>You can also use the {{domxref("PaymentRequest.onmerchantvalidation", "onmerchantvalidation")}} event handler property to set up the handler for this event:</p>

<pre class="brush: js notranslate">request.onmerchantvalidation = event =&gt; {
  event.complete(async () =&gt; {
    const merchantServerUrl = window.location.origin +
        '/validate?url=' + encodeURIComponent(event.validationURL);
    // get validation data, and complete validation;
    return await fetch(merchantServerUrl).then(response =&gt; response.text());
  });
};

const response = await request.show();</pre>

<p>For more information, see {{SectionOnPage("/en-US/docs/Web/API/Payment_Request_API/Concepts", "Merchant Validation")}}.</p>

<h2 id="Related_events">Related events</h2>

<ul>
 <li>{{event("payerdetailchange")}}, {{event("paymentmethodchange")}}, {{event("shippingaddresschange")}}, and {{event("shippingoptionchange")}}</li>
</ul>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.PaymentRequest.merchantvalidation_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Payment_Request_API">Payment Request API</a></li>
 <li><a href="/en-US/docs/Web/API/Payment_Request_API/Using_the_Payment_Request_API">Using the Payment Request API</a></li>
 <li>{{domxref("PaymentRequest.onmerchantvalidation", "onmerchantvalidation")}} event handler property</li>
 <li>{{SectionOnPage("/en-US/docs/Web/API/Payment_Request_API/Concepts", "Merchant validation")}}</li>
 <li>{{domxref("PaymentRequest")}}</li>
</ul>
</div>
